Index: trunk/source/processes/hadronic/models/radioactive_decay/CMakeLists.txt
===================================================================
--- trunk/source/processes/hadronic/models/radioactive_decay/CMakeLists.txt	(revision 1350)
+++ trunk/source/processes/hadronic/models/radioactive_decay/CMakeLists.txt	(revision 1350)
@@ -0,0 +1,18 @@
+#------------------------------------------------------------------------------
+# CMakeLists.txt
+# Module : G4hadronic_radioactivedecay
+# Package: Geant4.src.G4processes.G4hadronic.G4hadronic_models.G4hadronic_radioactivedecay
+#
+# CMakeLists.txt for building a single granular library.
+#
+# Generated on : 24/9/2010
+#
+# $Id: CMakeLists.txt,v 1.1 2010/09/29 19:06:45 bmorgan Exp $
+#
+#------------------------------------------------------------------------------
+
+if(GEANT4_BUILD_GRANULAR_LIBS)
+    include(Geant4MacroLibraryTargets)
+    GEANT4_GRANULAR_LIBRARY_TARGET(COMPONENT sources.cmake)
+endif()
+
Index: trunk/source/processes/hadronic/models/radioactive_decay/README_RDM
===================================================================
--- trunk/source/processes/hadronic/models/radioactive_decay/README_RDM	(revision 1350)
+++ trunk/source/processes/hadronic/models/radioactive_decay/README_RDM	(revision 1350)
@@ -0,0 +1,38 @@
+
+This README file provides instructions for reading the radioactive decay 
+schemes in the files zXX.aYYY found in the directory RadioactiveDecay3.2
+(most recent version).  This directory, as well as previous versions, is
+available from the Geant4 download page 
+
+http://geant4.web.cern.ch/geant4/support/download.shtml
+
+under the Data files heading. In order to use the radioactive decay module
+correctly, you must download and unpack the above directory in your local
+area, and set the environment variable
+
+G4RADIOACTIVEDATA
+
+to point to it. 
+
+**************************************************************************
+In each of the files, lines beginning with either a 'W' or a '#' are 
+comments.
+
+Lines beginning with a 'P' are headers, each of which describes a level of
+the nucleus.  The first number is the excitation energy in keV, the second 
+is the half life in seconds. Indented lines under the 'P' lines are decay 
+modes for that excitation.  There are two type of records here, 
+distinguished by the number of columns.
+
+If there are 3 columns only, this is a header which describes all decays of
+that type from this level.  The first column is the decay mode, the second
+column is zero, and the third column in the branching ratio to this mode, 
+as a fraction of unity.  Therefore, the third columns of all the 3-column
+records under a given 'P' line should sum to 1.0.
+
+If there are four columns, this is a record which describes a subset of the 
+decay type, specific to a given lower level in the daughter species.  The 
+first column is the decay type, the second column is the excitation level 
+of the daughter (in keV), and the third column is the branching ratio as a 
+percentage (! note... not a fraction of unity) of the total branching ratio 
+which came from the 3-column record for this decay.
Index: trunk/source/processes/hadronic/models/radioactive_decay/include/G4RadioactivityTable.hh
===================================================================
--- trunk/source/processes/hadronic/models/radioactive_decay/include/G4RadioactivityTable.hh	(revision 1350)
+++ trunk/source/processes/hadronic/models/radioactive_decay/include/G4RadioactivityTable.hh	(revision 1350)
@@ -0,0 +1,101 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+#ifndef G4RadioactivityTable_h
+#define G4RadioactivityTable_h 1
+// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+//
+// MODULE:              G4RadioactivityTable.hh
+//
+// Version:             0.b.4
+// Date:                14/04/00
+// Author:              F Lei & P R Truscott
+// Organisation:        DERA UK
+// Customer:            ESA/ESTEC, NOORDWIJK
+// Contract:            12115/96/JG/NL Work Order No. 3
+//
+// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+//
+// CHANGE HISTORY
+// --------------.
+//
+// 29 October 2010, F Lei, QinetiQ, UK
+// First created     
+//
+///////////////////////////////////////////////////////////////////////////////
+
+#include "globals.hh"
+#include <map>
+#include "G4ThreeVector.hh"
+
+using std::map;
+
+
+class G4RadioactivityTable
+{
+  // class description
+  // G4RadioactivityTable is the table of the radioactive isotopes and their
+  // activities.  It is used in the variance reduction mode to recorde the 
+  // induced radioactivity in the RDM sensitive volumes.
+  // class description - end
+
+public:
+  // constructor
+  //
+  G4RadioactivityTable ();
+
+  // destructor
+  virtual ~G4RadioactivityTable();
+
+  //  G4RadioactivityTable(const  G4RadioactivityTable &right);
+  
+public:
+  // with description
+  //
+  void AddIsotope( G4int, G4int, G4double, G4double);
+  // Add an isotope (Z,A,E) of rate to the table.
+  //
+  G4double GetRate(G4int, G4int, G4double);
+  // Get the rate of isotoe (Z,A,E)
+  //
+  G4int Entries() const;
+  // Get the total number of isotope spieces in the table
+  //
+  map<G4ThreeVector,G4double>*  GetTheMap();
+  // Return the stl map! Mainly for printing.
+  //
+private:
+  
+  map<G4ThreeVector,G4double> fRadioactivity;
+  
+};
+
+#endif
+
+
+
+
+
+
Index: trunk/source/processes/hadronic/models/radioactive_decay/sources.cmake
===================================================================
--- trunk/source/processes/hadronic/models/radioactive_decay/sources.cmake	(revision 1350)
+++ trunk/source/processes/hadronic/models/radioactive_decay/sources.cmake	(revision 1350)
@@ -0,0 +1,122 @@
+#------------------------------------------------------------------------------
+# sources.cmake
+# Module : G4hadronic_radioactivedecay
+# Package: Geant4.src.G4processes.G4hadronic.G4hadronic_models.G4hadronic_radioactivedecay
+#
+# Sources description for a library.
+# Lists the sources and headers of the code explicitely.
+# Lists include paths needed.
+# Lists the internal granular and global dependencies of the library.
+# Source specific properties should be added at the end.
+#
+# Generated on : 24/9/2010
+#
+# $Id: sources.cmake,v 1.2 2010/11/29 17:54:52 bmorgan Exp $
+# GEANT4 Tag $Name: geant4-09-04-ref-00 $
+#
+#------------------------------------------------------------------------------
+
+# List external includes needed.
+include_directories(${CLHEP_INCLUDE_DIRS})
+
+# List internal includes needed.
+include_directories(${CMAKE_SOURCE_DIR}/source/geometry/management/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/geometry/volumes/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/global/HEPGeometry/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/global/HEPRandom/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/global/management/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/intercoms/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/materials/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/particles/bosons/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/particles/hadrons/barions/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/particles/hadrons/ions/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/particles/hadrons/mesons/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/particles/leptons/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/particles/management/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/processes/electromagnetic/lowenergy/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/processes/electromagnetic/utils/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/processes/hadronic/cross_sections/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/processes/hadronic/management/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/processes/hadronic/management/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/processes/hadronic/models/de_excitation/management/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/processes/hadronic/models/de_excitation/photon_evaporation/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/processes/hadronic/models/de_excitation/util/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/processes/hadronic/models/util/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/processes/hadronic/processes/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/processes/hadronic/util/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/processes/management/include)
+include_directories(${CMAKE_SOURCE_DIR}/source/track/include)
+
+#
+# Define the Geant4 Module.
+#
+include(Geant4MacroDefineModule)
+GEANT4_DEFINE_MODULE(NAME G4hadronic_radioactivedecay
+    HEADERS
+        G4AlphaDecayChannel.hh
+        G4BetaFermiFunction.hh
+        G4BetaMinusDecayChannel.hh
+        G4BetaPlusDecayChannel.hh
+        G4ITDecayChannel.hh
+        G4KshellECDecayChannel.hh
+        G4LshellECDecayChannel.hh
+        G4MshellECDecayChannel.hh
+        G4NuclearDecayChannel.hh
+        G4NucleusLimits.hh
+        G4RIsotopeTable.hh
+        G4RadioactiveDecay.hh
+        G4RadioactiveDecayMode.hh
+        G4RadioactiveDecayRate.hh
+        G4RadioactiveDecayRateVector.hh
+        G4RadioactiveDecaymessenger.hh
+        G4RadioactivityTable.hh
+        G4UIcmdWithNucleusLimits.hh
+        G4UserLimitsForRD.hh
+    SOURCES
+        G4BetaFermiFunction.cc
+        G4NuclearDecayChannel.cc
+        G4NucleusLimits.cc
+        G4RIsotopeTable.cc
+        G4RadioactiveDecay.cc
+        G4RadioactiveDecayMode.cc
+        G4RadioactiveDecayRate.cc
+        G4RadioactiveDecayRateVector.cc
+        G4RadioactiveDecaymessenger.cc
+        G4RadioactivityTable.cc
+        G4UIcmdWithNucleusLimits.cc
+    GRANULAR_DEPENDENCIES
+        G4baryons
+        G4bosons
+        G4emlowenergy
+        G4emutils
+        G4geometrymng
+        G4globman
+        G4had_mod_util
+        G4hadronic_deex_management
+        G4hadronic_deex_photon_evaporation
+        G4hadronic_deex_util
+        G4hadronic_mgt
+        G4hadronic_proc
+        G4hadronic_util
+        G4hadronic_xsect
+        G4intercoms
+        G4ions
+        G4leptons
+        G4materials
+        G4mesons
+        G4partman
+        G4procman
+        G4track
+        G4volumes
+    GLOBAL_DEPENDENCIES
+        G4geometry
+        G4global
+        G4intercoms
+        G4materials
+        G4particles
+        G4track
+    LINK_LIBRARIES
+)
+
+# List any source specific properties here
+
Index: trunk/source/processes/hadronic/models/radioactive_decay/src/G4RadioactivityTable.cc
===================================================================
--- trunk/source/processes/hadronic/models/radioactive_decay/src/G4RadioactivityTable.cc	(revision 1350)
+++ trunk/source/processes/hadronic/models/radioactive_decay/src/G4RadioactivityTable.cc	(revision 1350)
@@ -0,0 +1,113 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+//
+// MODULE:              G4RadioactivityTable.cc
+//
+// Version:             0.a
+// Date:                29/10/2010
+// Author:              F Lei
+// Organisation:        QinetiQ UK
+// Customer:            ESA/ESTEC, NOORDWIJK
+// Contract:            12115/96/JG/NL Work Order No. 3
+//
+// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+//
+// CHANGE HISTORY
+// --------------
+//
+// 29 October 2010, F. Lei QinetiQ UK
+// first release.
+//
+///////////////////////////////////////////////////////////////////////////////
+
+
+#include "G4RadioactivityTable.hh"
+
+#include <map>
+
+G4RadioactivityTable::G4RadioactivityTable()
+{ 
+}
+///////////////////////////////////////////////////////////////////////////////
+//
+G4RadioactivityTable::~G4RadioactivityTable()
+{
+  fRadioactivity.clear(); 
+}
+///////////////////////////////////////////////////////////////////////////////
+//
+
+G4int G4RadioactivityTable::Entries() const
+{
+  return (G4int) fRadioactivity.size();
+}
+///////////////////////////////////////////////////////////////////////////////
+//
+void G4RadioactivityTable::AddIsotope(G4int Z, G4int A, G4double E, G4double rate)
+{
+  std::map<G4ThreeVector,G4double>::iterator it;
+  it = fRadioactivity.find(G4ThreeVector(Z,A,E));
+  if (it == fRadioactivity.end()) {
+    fRadioactivity[G4ThreeVector(Z,A,E)] = rate;
+  } else {
+    fRadioactivity[G4ThreeVector(Z,A,E)] += rate;
+  }
+}
+///////////////////////////////////////////////////////////////////////////////
+//
+G4double G4RadioactivityTable::GetRate(G4int Z, G4int A, G4double E)
+{
+  if (fRadioactivity.end() == fRadioactivity.find(G4ThreeVector(Z,A,E))) {
+    G4cout << G4ThreeVector(Z,A,E) << " is not in the map" << G4endl;
+    G4double rate = 0.;
+    return rate  ;
+  }
+  else
+    return fRadioactivity[G4ThreeVector(Z,A,E)];
+}
+///////////////////////////////////////////////////////////////////////////////
+//
+map<G4ThreeVector,G4double>*  G4RadioactivityTable::GetTheMap() 
+{
+  return &fRadioactivity;
+}
+///////////////////////////////////////////////////////////////////////////////
+//
+
+
+
+
+
+
+
+
+
+
+
+
+
+
